<?php

namespace Schaffen\BankIntegration\Cnab\Conciliacao\Cnab240;

use Carbon\Carbon;
use \Schaffen\BankIntegration\Contracts\Cnab\Conciliacao\Cnab240\TrailerLote as TrailerLoteContract;
use Schaffen\BankIntegration\MagicTrait;

class TrailerLote implements TrailerLoteContract
{
    use MagicTrait;

    /**
     * @var integer
     */
    public $loteServico;

    /**
     * @var integer
     */
    public $TipoRegistro;

    /**
     * @var string
     */
    public $tipoInscricao;

    /**
     * @var integer
     */
    public $numeroInscricao;

    /**
     * @var string
     */
    public $dataFinal;

    /**
     * @var integer
     */
    public $qtdRegistroLote;

    /**
     * @return mixed
     */
    public function getLoteServico()
    {
        return $this->loteServico;
    }

    /**
     * @param mixed $loteServico
     *
     * @return $this
     */
    public function setLoteServico($loteServico)
    {
        $this->loteServico = $loteServico;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getTipoRegistro()
    {
        return $this->TipoRegistro;
    }

    /**
     * @param mixed $TipoRegistro
     *
     * @return $this
     */
    public function setTipoRegistro($TipoRegistro)
    {
        $this->TipoRegistro = $TipoRegistro;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getTipoInscricao()
    {
        return $this->TipoRegistro;
    }

    /**
     * @param mixed $TipoRegistro
     *
     * @return $this
     */
    public function setTipoInscricao($TipoRegistro)
    {
        $this->TipoRegistro = $TipoRegistro;

        return $this;
    }

    /**
     * @return mixed
     */
    public function getNumeroInscricao()
    {
        return $this->TipoRegistro;
    }

    /**
     * @param mixed $TipoRegistro
     *
     * @return $this
     */
    public function setNumeroInscricao($TipoRegistro)
    {
        $this->TipoRegistro = $TipoRegistro;

        return $this;
    }

    // /**
    //  * @param string $format
    //  *
    //  * @return Carbon|null|string
    //  */
    // public function getDataFinal($format = 'd/m/Y')
    // {
    //     return $this->dataFinal instanceof Carbon
    //         ? $format === false ? $this->dataFinal : $this->dataFinal->format($format)
    //         : null;
    // }

    // /**
    //  * @param $dataFinal
    //  *
    //  * @param string $format
    //  *
    //  * @return $this
    //  */
    // public function setDataFinal($dataFinal, $format = 'dmY')
    // {
    //     $this->dataFinal = trim($dataFinal, '0 ') ? Carbon::createFromFormat($format, $dataFinal) : null;

    //     return $this;
    // }

     /**
     * @param string 
     */
    public function getDataFinal()
    {
        return $this->dataFinal;
    }

    /**
     * @param $dataLancamento
     *
     * @return $this
     */
    public function setDataFinal($dataFinal)
    {
        $this->dataFinal = date_format(date_create_from_format('dmY', $dataFinal), 'd/m/Y');

        return $this;
    }

    /**
     * @return mixed
     */
    public function getQtdRegistroLote()
    {
        return $this->qtdRegistroLote;
    }

    /**
     * @param mixed $qtdRegistroLote
     *
     * @return $this
     */
    public function setQtdRegistroLote($qtdRegistroLote)
    {
        $this->qtdRegistroLote = $qtdRegistroLote;

        return $this;
    }

}
